﻿#/*  #Copyright 2011 Cristina Bosco [bosco] AT di DOT unito DOT it

    #This file is part of TUTtoPENN converter rel. 1.0.

    #TUTtoPENN converter is free software: you can redistribute it and/or modify
    #it under the terms of the GNU General Public License as published by
    #the Free Software Foundation, either version 3 of the License, or
    #(at your option) any later version.

    #TUTtoPENN converter is distributed in the hope that it will be useful,
    #but WITHOUT ANY WARRANTY; without even the implied warranty of
    #MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    #GNU General Public License for more details.

    #You should have received a copy of the GNU General Public License
    #along with TUTtoPENN converter. If not, see <http://www.gnu.org/licenses/>.
#*/


#This file is part of the TUTtoPENN converter, which implements a conversion from TUT 
#native format to Penn Treebank format adapted to Italian (called TUT-Penn).
#The TUTtoPENN converter User MANUAL, which can be dowloaded from 
#http://www.di.unito.it/~tutreeb/TUTtoPENN/TUTtoPENNconverter-manual.zip), describes 
#the organization and use of the converter.
#
#This is the MAIN MODULE, i.e. the module that the user has to call to start the converter
#on an input file in .tut format.
#The call of this module can be done by using one among the following values for the 
#PARAMETER:
# [] (no parameter), for the format where only the PoS tagging is converted in a 
#Penn-like style (the output is in outpreproc.out)
# [-c], for the conversion in CONStituency-TUT format (the output is in outconstutpar.ctu)
# [-a], for the conversion in AUGmented-Penn format (the output is in outaugpennpar.aug)
# [-p], for the conversion in TUT-Penn format (the output is in outpennpar.pen).
#Example: the following call
#perl TUTtoPENNconverter0_1.pl -a filename.tut
#produces the conversion of the sentences of the filename.tut in AUGmented-Penn format.


@arrayfrasi = ();
$numparametri = @ARGV;
print "in converter\n";
if ($numparametri > 2){
	print $numparametri," are too many parameters;\n only one of the following valid optional parameters has to be included
	between 'TUTtoPENNconverter0_1.pl' and the input filename.tut':\n 
	nothing for the conversion of the PoS tagging, -c for CONStituencyTUT format, -a for AUGmentedPenn 
	format, -p for Penn format\n";}
else{ if ($numparametri == 1){			
print "conversion of the PoS only\n";
			require 'TUTtoPENNpreprocessor1_0.pl';	#call preprocessor
			open(FILEHANDLEpreproc, ">outpreproc.out") or die ("cannot open outpreproc.out");	#open outpreproc.out
			print FILEHANDLEpreproc package_preproc::main_preproc(@ARGV);	#write in outpreproc.out the result
			close (FILEHANDLEpreproc);  		 
     	}
     	else{
     			if ($numparametri == 2){			
     					$parameter = shift(@ARGV);		 
						require 'TUTtoPENNpreprocessor1_0.pl';	#call preprocessor
						open(FILEHANDLEpreproc, ">outpreproc.out") or die ("cannot open outpreproc.out");	#open outpreproc.out
						print FILEHANDLEpreproc package_preproc::main_preproc(@ARGV);	#write in outpreproc.out the result
						close (FILEHANDLEpreproc);  		
						require 'TUTtoPENNconstuttifier1_0.pl';	#call the other modules
						require 'TUTtoPENNaugpennifier1_0.pl';
						require 'TUTtoPENNpennifier1_0.pl';
						require 'TUTtoPENNparenthetizer1_0.pl';
						open (FILEHANDLEinput, "<outpreproc.out") or die ("cannot read outpreproc.out");	#read outpreproc.out
						@inputarray = ();		
						while (<FILEHANDLEinput>){	
								push(@inputarray,$_);
						}
						close (FILEHANDLEinput);	
						open(FILEHANDLEconstut, ">outconstut.out") or die ("cannot open outconstut.out");	#open outconstut.out
						print FILEHANDLEconstut package_constut::main_constut(@inputarray);	#write in outconstut.out 
						close (FILEHANDLEconstut);
						@arrayconstut = ();		
						open(FILEHANDLEconstut, "<outconstut.out") or die ("cannot open outconstut.out");	#read outconstut.out
						while (<FILEHANDLEconstut>){	
								push(@arrayconstut,$_);
						}
						close (FILEHANDLEconstut);
						if ($parameter eq '-c'){						#if the required format is constituencyTUT
print "conversion in CONSTITUENCY-TUT\n";
								open (FILEHANDLEpar, ">outconstutpar.ctu") or die ("cannot open outconstutpar.ctu");		#open outconstutpar.out
								print FILEHANDLEpar package_parenth::main_parenth($parameter,@arrayconstut);	#write in outconstutpar.out 
								close (FILEHANDLEpar);
						}
						else{													#if the required format is NOT constituency-TUT 
								open(FILEHANDLEaugpen, ">outaugpen.out") or die ("cannot open outaugpen.out");	#open outaugpen.out
								print FILEHANDLEaugpen package_augpen::main_augpen(@arrayconstut);	#write in outaugpen.out 
								close (FILEHANDLEaugpen);
								@arrayaugpen = ();		
								open(FILEHANDLEaugpen, "<outaugpen.out") or die ("cannot open outaugpen.out");	#read outaugpen.out
								while (<FILEHANDLEaugpen>){
										push(@arrayaugpen,$_);
								}
								close (FILEHANDLEaugpen);
								if ($parameter eq '-a'){				#if the required format is augmented-penn
print "conversion in AUGMENTED-PENN\n";
										open (FILEHANDLEpar, ">outaugpenpar.ape") or die ("cannot open outaugpenpar.ape");	#open outaugpenpar.ape
										print FILEHANDLEpar package_parenth::main_parenth($parameter,@arrayaugpen);	#write in outaugpenpar.ape 
										close (FILEHANDLEpar);
		    					}
		    					else{											#else, if the required format is Penn
		    					open(FILEHANDLEpenn, ">outpenn.out") or die ("cannot open outpenn.out");	#open outpenn.out
										print FILEHANDLEpenn package_penn::main_penn(@arrayaugpen);	#write in outpenn.out
										close (FILEHANDLEpenn);
										@arraypenn = ();		
										open(FILEHANDLEpenn, "<outpenn.out") or die ("cannot open outpenn.out");	#read outpenn.out
										while (<FILEHANDLEpenn>){
												push(@arraypenn,$_);
										}
										close (FILEHANDLEpenn);
										if ($parameter eq '-p'){
print "conversion in PENN\n";
												open (FILEHANDLEpar, ">outpennpar.pen") or die ("cannot open outpennpar.pen");	#open outpennpar.pen
												print FILEHANDLEpar package_parenth::main_parenth($parameter,@arraypenn);	#write in outpennpar.pen 
												close (FILEHANDLEpar);
										}
								}			  
						}
		   		}
	    }    
}

