#/*  #Copyright 2011 Cristina Bosco [bosco] AT di DOT unito DOT it

    #This file is part of TUTtoPENN converter rel. 1.0.

    #TUTtoPENN converter is free software: you can redistribute it and/or modify
    #it under the terms of the GNU General Public License as published by
    #the Free Software Foundation, either version 3 of the License, or
    #(at your option) any later version.

    #TUTtoPENN converter is distributed in the hope that it will be useful,
    #but WITHOUT ANY WARRANTY; without even the implied warranty of
    #MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    #GNU General Public License for more details.

    #You should have received a copy of the GNU General Public License
    #along with TUTtoPENN converter. If not, see <http://www.gnu.org/licenses/>.
#*/


#This file is part of the TUTtoPENN converter, which implements a conversion from TUT 
#native format to Penn Treebank format adapted to Italian (called TUT-Penn).
#The TUTtoPENN converter User MANUAL, which can be dowloaded from 
#http://www.di.unito.it/~tutreeb/TUTtoPENN/TUTtoPENNconverter-manual.zip), describes 
#the organization and use of the converter.
#
#This is the MODULE for parenthetical notation, i.e. the module that is called to format 
#the arrays that the others (FIRST, SECOND, THIRD and FOURTH) modules produce in 
#a parenthetical, more readable format.
#The call of this module is done by the MAIN module as a postprocessing of the output 
#of the last called module of the conversion process.

#The main comments are in English, the minor in Italian

package package_parenth;
BEGIN{}

######## MAIN #####################################################################
#manages the call of the rest of the module on the single sentences included in the input file and modifies the annotation of 
#parenthesis of the parenthetical sentences in a Penn style.

sub main_parenth{
print "in parenthetizer\n";
$contarighe = 0; 		#contiene il numero righe del file ancora da leggere
@frase_tree = ();		#contiene l'albero della frase da mettere in forma parentetica
$frase_par = '';		#contiene la frase in forma parentetica
$parameter = shift(@_);
$contarighe = scalar(@_);	#numero di righe del file di input
while ($contarighe > 0){        #fino a quando ci sono righe di input
    @frase_tree = ();
    while ($riga !~ m/^\s/){	#se la riga inizia con carattere vuoto
    	$riga = shift(@_);		#legge la riga di input
    	$contarighe = --$contarighe;
    	if ($riga =~ m/\*\*\*\*/){       	#se la riga inizia con *
       		$titolo = $riga;     	#assegna riga a $titolo
       		$titolo =~ s/\\//;
print $titolo,"\n";
		}
		else{if ($riga =~ m/^\(/){        #se la riga inizia con parentesi aperta
					if ((($parameter eq '-p') or ($parameter eq '-a')) and ($riga =~ m/PUNCT/) and 
					    ($riga =~ m/\/\(\)\[/)){
								$riga =~ s/\/\(\)\[/\/\-LRB\-\)\[/;
					}
					elsif ((($parameter eq '-p') or ($parameter eq '-a')) and ($riga =~ m/PUNCT/) and 
					   		 ($riga =~ m/\/\[\)\[/)){
								$riga =~ s/\/\[\)\[/\/\-LSB\-\)\[/;
					}
					elsif (($riga =~ m/PUNCT/) and 		#se la parola contenuta nella riga e' parentesi chiusa
						($riga =~ m/CLOSE\+PARENTHETICAL/) and #la sostituisce provvisoriamente con doppia virgola
						($riga =~ m/\)\)/)){		#e alla fine sostituira' la doppia virgola con ) (vedi linea 60)
							$riga =~ s/\)\)/\,\,\)/;
					}
					elsif ((($parameter eq '-p') or ($parameter eq '-a')) and ($riga =~ m/PUNCT/) and 
					    	($riga =~ m/\/\)\)\[/)){
								$riga =~ s/\/\)\)\[/\/\-RRB\-\)\[/;
					}
					elsif ((($parameter eq '-p') or ($parameter eq '-a')) and ($riga =~ m/PUNCT/) and 
						   ($riga =~ m/\/\]\)\[/)){
								$riga =~ s/\/\]\)\[/\/\-RSB\-\)\[/;
					}
					elsif ((($parameter eq '-p') or ($parameter eq '-a')) and 
					        (($riga =~ m/PUNCT\-SEPARATOR/) and ($riga =~ m/\/\)/))){
									$riga =~ s/\)\)/\,\,\)/;
					}
        		   	push (@frase_tree,$riga);	#la mette nell'array
	     	  }
		}
    }  
    $frase_par = apply_parenthesis($parameter,@frase_tree);
	$frase_par =~ s/^\(//;	#elimina la parentesi iniziale che non occorre in augpenn
	$frase_par = substr $frase_par,0,(length $frase_par)-3; #e quella finale
	$file_frasi_par = $file_frasi_par."\n\n\n".$titolo."\n".$frase_par;  
   	$frase_par = '';
}
$file_frasi_par =~ s/^\n\n//;
$file_frasi_par =~ s/\,\,/\)/g;
$file_frasi_par =~ s/\-TOP\b//g;
return $file_frasi_par;
}



#### last_spacing #####################

sub last_spacing{
	my $frase = shift(@_);
	my @splittedfrase = split(/\(VP/,$frase);
	foreach $el(@splittedfrase){
			$newel = '((VVPP'.$el;
	}
	foreach $it(@splittedfrase){
			@splittedit = split(/\(VMA/,$it);
			foreach $ee(@splittedit){
					$newee = '((VVMMAA'.$ee;
					if ($newee ne '((VVMMAA((VVPP '){
							$newnewee = "\n".$ee;
							@splittedfrase = sostituisciinarray($ee,$newnewee,@splittedfrase);						
					}
			}
	}
	return $frase;
}



#### apply-parenthesis #####################

sub apply_parenthesis{
  	my $parameter = shift(@_);
   	my @inputtree = @_;
  	my @tree = ();	
  	my $parenthetical = '';
   	my $root = '';
   	my $trovato = 0;
   	my $ini = '';
   	while (scalar(@inputtree) > 0){   
			$riga = shift(@inputtree);		
			if (($riga !~ m/]/) and ($trovato == 0)){ 	#cerca la riga che contiene la testa della frase
					$root = $riga;
					$trovato = 1;
			}
			else{if ($riga =~ m/]/) {		#mette il contenuto della riga dentro l'array @tree
						push (@tree,$riga);
	      		   }
			}
   }
	$parenthetical = makepar($parameter,$ini,$root,@tree).')'; 	#chiama la subroutine che costruisce il formato con parentesi
	$parenthetical = removevoidpar($parenthetical);
	$parenthetical = indent($parenthetical);	#chiama la subroutine che introduce gli a capo e le indentazioni
	$parenthetical = removerelaz($parameter,$parenthetical);
	return spazia($parenthetical,$ini,$ini)."\n\n";
}


##### INDENT ######################################################################################

sub indent {
	my $seconda = shift(@_);
	$seconda =~ s/^\s//;
	my $prima = '';
	$prima = (substr $seconda,0,((index $seconda,' ') +1));
	$seconda = substr $seconda,((index $seconda, ' ') +1);
	while ($seconda ne '') {
		if (($seconda =~ m/^\(VP/) or ($seconda =~ m/^\(DP/) or ($seconda =~ m/^\(NP/) or
	    	    ($seconda =~ m/^\(PP/) or ($seconda =~ m/^\(CONJP/) or ($seconda =~ m/^\(PUNCT/) or
	    	    ($seconda =~ m/^\(ADVP/) or ($seconda =~ m/^\(ADJP/) or ($seconda =~ m/^\(PRN/)
		    	or ($seconda =~ m/^\(S\s/) or ($seconda =~ m/^\(S\-/) or ($seconda =~ m/^\(Sbar/)
		   	 	or ($seconda =~ m/^\(Vbar/) or ($seconda =~ m/^\(Dbar/) or ($seconda =~ m/^\(Nbar/)
		    	or ($seconda =~ m/^\(ADJbar/) or ($seconda =~ m/^\(ADVbar/) or ($seconda =~ m/^\(SBAR/)
		     	or ($seconda =~ m/^\(CONJ/) or ($seconda =~ m/^\(S\+RELCL\+REDUC/)){
		    			$prima = $prima.'*#*#*'.(substr $seconda,0,((index $seconda,' ') +1));
						$seconda = substr $seconda,((index $seconda, ' ') +1);
						if ($prima =~ m/\)\)\)$/){
								$prima = $prima.'*#*#*';
						}
						if ($seconda !~ m/\s/){
								$prima = $prima.$seconda;
			       				$seconda = '';
						}
		}
		else{if ($seconda =~ m/\s/){
						$primocarattere = substr $seconda,0,((index $seconda, ' ') + 1);
	       				$seconda = substr $seconda,((index $seconda, ' ') + 1);
	       				$prima = $prima.$primocarattere;
						if ($prima =~ m/\)\)\)$/){
								$prima = $prima.'*#*#*';
						}
		       }
		     	else{$prima = $prima.$seconda;
			    	   $seconda = '';
		     	}
	    }
	}
	$iniz = '';	
	$prima = spazia($prima,$iniz,$iniz);
	return $prima;
}


###### SPAZIA #########################################################################

sub spazia {
	my $argomento = shift(@_);
	$newargomento = shift(@_);
	$spazio = shift(@_);;
	my $contaperte = 0;
	my $contachiuse = 0;
	my $riga = '';
	my $tempriga1 = '';
	my $tempriga2 = '';
	my $differenza = 0;
	my $subriga = '';
	my $punto = '';	
	if ($argomento ne ''){ 	#se la frase non e' vuota
			if ($argomento =~ m/\*\#\*\#\*/){ #se la frase include degli a capo (= *#*#* inseriti dalla subroutine indent)
					$riga = substr $argomento,0,((index $argomento,'*#*#*') + 5);	#isola la singola riga (delimitata da 2 a capo)
					$tempriga1 = $riga;	#conta il numero di parentesi aperte presenti sulla riga
					while ($tempriga1 =~ m/\(/){
							$contaperte = ++$contaperte;
							$tempriga1 = substr $tempriga1,((index $tempriga1,'(') + 1);
					}
					$tempriga2 = $riga;	#conta il numero di parentesi chiuse presenti sulla riga
					while ($tempriga2 =~ m/\)/){
							$contachiuse = ++$contachiuse;
							$tempriga2 = substr $tempriga2,((index $tempriga2,')') + 1);
					}
					if ($contaperte > $contachiuse){	#se il numero di parentesi aperte eccede quello delle chiuse
							$differenza = $contaperte - $contachiuse;
							for ($loop_index = 0; $loop_index < $differenza; $loop_index++){	   #per ogni aperta
									$spazio = $spazio.'    ';	#in piu' aggiunge tre spazi
							}
					}
					else{if ($contachiuse > $contaperte){	#se il numero di parentesi chiuse eccede quello delle aperte
									$differenza = $contachiuse - $contaperte;
									for (my $loop_index = 0; $loop_index < $differenza; $loop_index++){	#per ogni chiusa
											$spazio = substr $spazio,3;	#in piu' toglie 3 spazi
									}
		      				}
					}	#attacca la nuova riga a quelle gia' analizzate e vi sostituisce il *#*#* con \n (= a capo)
					$newargomento = $newargomento.(substr $riga,0,(index $riga,'*#*#*'))."\n".$spazio; 
					$argomento = substr $argomento,((index $argomento,'*#*#*') + 5);	#aggiorna argomento e
					$argomento = spazia($argomento,$newargomento,$spazio);	#richiama ricorsivamente spazia
			}
			else{	$newargomento = "( ".$newargomento.$argomento." )";
			}
	}
	return $newargomento;
}


########## MAKEPAR ################################################################################

sub makepar{
	my $parameter = shift(@_);
	$parenth = shift(@_);
    $mkroot = shift(@_);
	@mktree = @_;
	my @mkfigli = figli($mkroot,@mktree);
	my $root_per_parenth = '';
	if ($mkroot !~ m/\/\)/){	#se root non e' un nodo non terminale
			if (($parameter ne '-p') and ($parameter ne '-a')){
					$root_per_parenth = substr $mkroot,1,((index $mkroot,')') - 1); #prende la categ sintagmatica, il numero=posizione e la parola
			}
			else{$root_per_parenth = substr $mkroot,1,((index $mkroot,')') - 1);	#serve solo per penn
					$datogliere = substr $mkroot,(index $mkroot,' ')+1;
					$datogliere = substr $datogliere,0,(index $datogliere, '/')+1;
					$root_per_parenth =~ s/$datogliere//;
			}
	}
	else{$root_per_parenth = substr $mkroot,1,((index $mkroot,' ') - 1); #altrimenti prende la categ sintagmatica solamente
	}
       	$parenth = $parenth.' ('.$root_per_parenth;
	if (scalar(@mkfigli) > 0){	#richiama ricorsivamente makepar
		foreach $fig(@mkfigli){
			makepar($parameter,$parenth,$fig,@mktree);
			$parenth = $parenth.')';
			@mkfigli = sostituisciinarray($fig,'',@mkfigli);
		}
	}
return $parenth;
}


#########################################################################################################

sub figli{
	my $arg =  shift(@_);
	my @frase = @_;
	my $posiz = position_in_tree($arg);
	my @arrayfigli = ();
	foreach $elem (@frase){                #per ogni elemento della frase
		$padreelem = substr $elem,((rindex $elem,'[') + 1);    #calcola la posizione del padre
		$padreelem = substr $padreelem, 0, (rindex $padreelem,']');
 		if ($padreelem eq $posiz){     #e la confronta con la posizione di $arg
			push(@arrayfigli,$elem);  #se corrispondono mette l'elemento nell'array dei figli
		}
	}
	@sortedarrayfigli = sort {compar($a,$b,@frase)} @arrayfigli;
return @sortedarrayfigli;
}


#########################################################################################################

sub figli2{
	my $arg =  shift(@_);
	my @frase = @_;
	my $posiz = position_in_tree($arg);
	my @arrayfigli = ();
	foreach $elem (@frase){                #per ogni elemento della frase
		$padreelem = substr $elem,((rindex $elem,'[') + 1);    #calcola la posizione del padre
		$padreelem = substr $padreelem, 0, (rindex $padreelem,']');
 		if ($padreelem eq $posiz){     #e la confronta con la posizione di $arg
			push(@arrayfigli,$elem);  #se corrispondono mette l'elemento nell'array dei figli
		}
	}
	return @arrayfigli;
}


#########################################################################################################

sub compar{
	my $arg1 = shift(@_);
	my $arg2 = shift(@_);
	my @tree = @_;
	my $spinapos1 = '';
	my $spinapos2 = '';
	my $found1 = 0;
	my $found2 = 0;
	my @figl = ();
	$spinapos1 = pos_in_ttree($arg1);
	if ($spinapos1 =~ m/\./){
			$spinapos1 = substr $spinapos1,0,(index $spinapos1,'.');
	}
	if ($spinapos1 =~ m/\-/){
			$spinapos1 = substr $spinapos1,0,(index $spinapos1,'-');
	}
	$spinapos2 = pos_in_ttree($arg2);
	if ($spinapos2 =~ m/\./){
			$spinapos2 = substr $spinapos2,0,(index $spinapos2,'.');
	}
	if ($spinapos2 =~ m/\-/){
			$spinapos2 = substr $spinapos2,0,(index $spinapos2,'-');
	}
	
	if ((($arg1 =~ m/SUBJ/) or ($arg1 =~ m/SBJ/)) and 
		($arg1 !~ m/PREDCOMPL/) and ($arg1 !~ m/RMODPRED/) and 
		($arg1 !~ m/EXTP/) or ($arg1 !~ m/PUNCT\-SEPARATOR/)){	#se arg1 e' SUBJ (ma non predcompl o extraposto)
				if (($arg1 =~ m/\*\[/) and ($arg1 =~ m/\.1/)){ 	
					return -1;
				}
				else{@figl = figli2($arg1,@tree); 					#ne cerco i figli 
						foreach $fi(@figl){												
								if (($fi =~ m/\*\[/) and ((($fi =~ m/SUBJ/) or ($fi =~ m/SBJ/)) #se un figlio e' SUBJ ed e' traccia
					    			and (($fi !~ m/PREDCOMPL/) and ($fi !~ m/RMODPRED/) and 
					    			($fi !~ m/EXTP/)))){
											$found1 = ++$found1; 														#allora incrementa found
								}
								else{if (($fi =~ m/barSUBJ/) or ($fi =~ m/barSBJ/)){				#altrimenti, se il figlio e' proiezione intermedia
												foreach $figlio(figli($fi,@tree)){								#fa la verifica sui figli di figlio
														if (($figlio =~ m/\*\[/) and ((($figlio =~ m/SUBJ/) or ($figlio =~ m/SBJ/)) 
						    								and ($figlio !~ m/PREDCOMPL/) and ($figlio !~ m/RMODPRED/) and 
		                                        			($figlio !~ m/EXTP/))){
																	$found1 = ++$found1;
														}
												}
						  			   }
								}
						}
				}
	}
	else{if ((($arg2 =~ m/SUBJ/) or ($arg2 =~ m/SBJ/)) and 
		    ($arg2 !~ m/PREDCOMPL/) and ($arg2 !~ m/RMODPRED/) and 
		    ($arg2 !~ m/EXTP/)){	#se arg2 e' SUBJ ed e' traccia deve precedere arg1
		    		if (($arg2 =~ m/\*\[/) or ($arg2 =~ m/\.1/)){ 
						return 1;
					}
					else{@fig = figli2($arg2,@tree); 					#ne cerco i figli 
							foreach $fi(@fig){	
									if (($fi =~ m/\*\[/) and ((($fi =~ m/SUBJ/) or ($fi =~ m/SBJ/)) #se un figlio e' SUBJ ed e' traccia
					    				and (($fi !~ m/PREDCOMPL/) and ($fi !~ m/RMODPRED/) and 
					    				($fi !~ m/EXTP/)))){
												$found2 = ++$found2; 														#allora incrementa found
									}
									else{if (($fi =~ m/barSUBJ/) or ($fi =~ m/barSBJ/)){				#altrimenti, se il figlio e' proiezione intermedia
													foreach $figlio(figli($fi,@tree)){								#fa la verifica sui figli di figlio
															if (($figlio =~ m/\*\[/) and ((($figlio =~ m/SUBJ/) or ($figlio =~ m/SBJ/)) 
						    									and ($figlio !~ m/PREDCOMPL/) and ($figlio !~ m/RMODPRED/) and 
		                                        				($figlio !~ m/EXTP/))){
																		$found2 = ++$found2;
															}
													}
							  			   }
									}
							}
					}
			}
	}
	if (($found1 ==0) and ($found2 ==0)){
			return (position_in_tree($arg1) <=> position_in_tree($arg2));
	}
	elsif ($found1 > 0){
			return -1;
	}
	elsif ($found2 >0){
			return 1;
    }
}


#########################################################################################################

sub pos_in_ttree{
	my $nodo = shift(@_);
	my $posinttree = substr $nodo,((index $nodo,' ')+1);
	$posinttree = substr $posinttree, 0,(index $posinttree,'/');
	return $posinttree;
}


#########################################################################################################

sub position_in_tree{
	my $arg =  shift(@_);
	my $posiz = substr $arg, 0, (index $arg, '/');
		$posiz = substr $posiz,((index $posiz,' ') + 1);
return $posiz;
}


#### sostituisciinarray ##################################################################################

sub sostituisciinarray {
	my $vecchio = shift(@_);
        my $nuovo = shift(@_);
	my @array = @_;
	my @arraytemp1 = ();
	foreach $elemento(@array){
		if (position_in_tree($elemento) ne position_in_tree($vecchio)){
			push (@arraytemp1,$elemento);
		}
		else {push (@arraytemp1,$nuovo);
		}
	}
	@array = @arraytemp1;
	return @array;
}


###### removevoidpar###################################################################################

sub removevoidpar{
	my $string = shift(@_);
	$string =~ s/\s\(\)//g;
	return $string;
}


###################################################################################################

sub removerelaz{
	my $parameter = shift(@_);
	my $string = shift(@_);
	$string =~ s/DPSUBJ/DP\-SUBJ/g;
	$string =~ s/NPSUBJ/NP\-SUBJ/g;
	$string =~ s/CONJPSUBJ/CONJP\-SUBJ/g;
	$string =~ s/ADJPSUBJ/ADJP\-SUBJ/g;
	$string =~ s/SSUBJ/S\-SUBJ/g;
	$string =~ s/VPSUBJ/VP\-SUBJ/g;
	$string =~ s/PPSUBJ/PP\-SUBJ/g;
	$string =~ s/DbarSUBJ/Dbar/g;
	$string =~ s/ART~DESUBJ/ART~DE/g;
	$string =~ s/ART~INSUBJ/ART~IN/g;
	$string =~ s/NbarSUBJ/Nbar/g;
	$string =~ s/NOU~CSSUBJ/NOU~CS/g;
	$string =~ s/NOU~CPSUBJ/NOU~CP/g;
	$string =~ s/NOU~CASUBJ/NOU~CA/g;
	$string =~ s/NOU~PRSUBJ/NOU~PR/g;
	$string =~ s/ART~DE-SBJ/ART~DE/g;
	$string =~ s/ART~IN-SBJ/ART~IN/g;
	$string =~ s/NOU~CS-SBJ/NOU~CS/g;
	$string =~ s/NOU~CP-SBJ/NOU~CP/g;
	$string =~ s/NOU~CA-SBJ/NOU~CA/g;
	$string =~ s/NOU~PR-SBJ/NOU~PR/g;	
	$string =~ s/PRO~POSUBJ/PRO~PO/g;
	$string =~ s/PRO~INSUBJ/PRO~IN/g;
	$string =~ s/PRO~RISUBJ/PRO~RI/g;
	$string =~ s/PRO~DESUBJ/PRO~DE/g;
	$string =~ s/PRO~IDSUBJ/PRO~ID/g;
	$string =~ s/PRO~LOSUBJ/PRO~LO/g;
	$string =~ s/PRO~PESUBJ/PRO~PE/g;
	$string =~ s/PRO~RESUBJ/PRO~RE/g;
	$string =~ s/PRO~POSBJ/PRO~PO/g;
	$string =~ s/PRO~INSBJ/PRO~IN/g;
	$string =~ s/PRO~RISBJ/PRO~RI/g;
	$string =~ s/PRO~DESBJ/PRO~DE/g;
	$string =~ s/PRO~IDSBJ/PRO~ID/g;
	$string =~ s/PRO~LOSBJ/PRO~LO/g;
	$string =~ s/PRO~PESBJ/PRO~PE/g;
	$string =~ s/PRO~RESBJ/PRO~RE/g;
	$string =~ s/PRO~PO\-SBJ/PRO~PO/g;
	$string =~ s/PRO~IN\-SBJ/PRO~IN/g;
	$string =~ s/PRO~RI\-SBJ/PRO~RI/g;
	$string =~ s/PRO~DE\-SBJ/PRO~DE/g;
	$string =~ s/PRO~ID\-SBJ/PRO~ID/g;
	$string =~ s/PRO~LO\-SBJ/PRO~LO/g;
	$string =~ s/PRO~PE\-SBJ/PRO~PE/g;
	$string =~ s/PRO~RE\-SBJ/PRO~RE/g;
	$string =~ s/PREPSUBJ/PREP/g;
	$string =~ s/PREP\-SBJ/PREP/g;
	$string =~ s/PUNCTEND/PUNCT\-END/g;
	$string =~ s/PUNCTCOORD/PUNCT\-COORD/g;
	$string =~ s/ADJ~DESUBJ/ADJ~DE/g;
	$string =~ s/ADJ~DISUBJ/ADJ~DI/g;
	$string =~ s/ADJ~ORSUBJ/ADJ~OR/g;
	$string =~ s/ADJ~QUSUBJ/ADJ~QU/g;
	$string =~ s/ADJ~INSUBJ/ADJ~IN/g;
	$string =~ s/ADJ~POSUBJ/ADJ~PO/g;
	$string =~ s/ADJbarSUBJ/ADJbar/g;
	$string =~ s/SSUBJ/S/g;
	$string =~ s/SbarSUBJ/Sbar/g;
	$string =~ s/VbarSUBJ/Vbar/g;
	$string =~ s/NUMR2SUBJ/NUMR2/g;
	$string =~ s/VMA~INSUBJ/VMA~IN/g;
	$string =~ s/VMO~RESUBJ/VMO~RE/g;
	$string =~ s/CONJSUBJ/CONJ/g;
	$string =~ s/PREPSBJ/PREP/g;
	$string =~ s/PREP\-SBJ/PREP/g;
	$string =~ s/PUNCTCOORD/PUNCT\-COORD/g;
	$string =~ s/ADJ~DE-SBJ/ADJ~DE/g;
	$string =~ s/ADJ~DI-SBJ/ADJ~DI/g;
	$string =~ s/ADJ~OR-SBJ/ADJ~OR/g;
	$string =~ s/ADJ~QU-SBJ/ADJ~QU/g;
	$string =~ s/ADJ~IN-SBJ/ADJ~IN/g;
	$string =~ s/ADJ~PO-SBJ/ADJ~PO/g;
	$string =~ s/S-SBJ/S/g;
	$string =~ s/NUMR2-SBJ/NUMR2/g;
	$string =~ s/VMA~IN-SBJ/VMA~IN/g;
	$string =~ s/VMO~RE-SBJ/VMO~RE/g;
	$string =~ s/CONJ-SBJ/CONJ/g;
	$string =~ s/\,C/\,/g;
	$string =~ s/ADJP2/PRDT/g;
	$string =~ s/ADJbar2/ADJbar/g;
if ($parameter eq '-p'){
	$string =~ s/PPSUB/PP-PRD/g;
	$string =~ s/NPSUB/NP-PRD/g;
	$string =~ s/ADJPSUB/ADJP-PRD/g;
	$string =~ s/SSUB/S-PRD/g;
	$string =~ s/ADVPSUB/ADVP-PRD/g;
	$string =~ s/PPOB/PP-PRD/g;
	$string =~ s/NPOB/NP-PRD/g;
	$string =~ s/ADJPOB/ADJP-PRD/g;
	$string =~ s/SOB/S-PRD/g;
	$string =~ s/ADVPOB/ADVP-PRD/g;
	$string =~ s/PPINDOB/PP-PRD/g;
	$string =~ s/NPINDOB/NP-PRD/g;
	$string =~ s/ADJPINDOB/ADJP-PRD/g;
	$string =~ s/SINDOB/S-PRD/g;
	$string =~ s/ADVPINDOB/ADVP-PRD/g;
	$string =~ s/\+BASE//g;
	$string =~ s/\+ADVERS//g;
	$string =~ s/\+CORRELAT//g;
	$string =~ s/\%EXTRAPOSED\-SBJ/\-EXTPSBJ/g;
	$string =~ s/EXTRAPOSED\-SBJ/EXTPSBJ/g;
	$string =~ s/Nbar/NP/g;
	$string =~ s/SBJ\-SBJ/SBJ/g;
	$string =~ s/S\+RELCL/S/g;
	$string =~ s/\%\-/\-/g;
	$string =~ s/ADJ\~DI2/ADJ\~DI/g;
	
}
	$string =~ s/NUMR2/NUMR/g;
	$string =~ s/\(NONE/\(\-NONE\- \*/g;
	$string =~ s/\(NONCO/\(\-NONE\- \*\-/g;
	$string =~ s/\(NONN/\(\-NONE\- \*/g;
	$string =~ s/ART~DE-SBJ/ART~DE/g;
	$string =~ s/ART~INSBJ/ART~IN/g;
	if ($parameter eq '-p'){
			$string =~ s/\(PUNCT \./\(\. \./g;
			$string =~ s/\(PUNCT \?/\(\. \?/g;	
			$string =~ s/\(PUNCT \!/\(\. \!/g;
			$string =~ s/\(PUNCT \-LRB\-/\(-LRB- -LRB-/g;
			$string =~ s/\(PUNCT \-RRB\-/\(-RRB- -RRB-/g;
			$string =~ s/\(PUNCT \-LSB\-/\(-LRB- -LSB-/g;
			$string =~ s/\(PUNCT \-RSB\-/\(-RRB- -RSB-/g;			
			if (($string !~ m/RRB/) and ($string !~ m/LRB/)){
			}
			$string =~ s/\(PUNCT \:/\(\: \:/g;
			$string =~ s/\(PUNCT \;/\(\: \;/g;
			$string =~ s/\(PUNCT \,/\(\, \,/g;
			$string =~ s/\(PUNCT \'/\(\' \'/g;	
			$string =~ s/\(PUNCT \"/\(\" \"/g;
			$string =~ s/\*\-\s/\*\-/g;
			$string =~ s/\@/\-/g;
			$string =~ s/\(DP \(NUMR /\(NP \(NUMR /g;
			$string =~ s/\(DP\-SBJ \(NUMR /\(NP\-SBJ \(NUMR /g;
			$string =~ s/\-LOCUT//g;
	}	
if ($parameter eq '-a'){			
			$string =~ s/\(PUNCT\-OPEN\+PARENTHETICAL \-LRB\-/\(-LRB- -LRB-/g;
			$string =~ s/\(PUNCT\-CLOSE\+PARENTHETICAL \-RRB\-/\(-RRB- -RRB-/g;
			$string =~ s/\(PUNCT\-CLOSE\+PARENTHETICAL \,\,/\(-RRB- -RRB-/g;
			$string =~ s/\(PUNCT\-OPEN\+PARENTHETICAL \-LSB\-/\(-LRB- -LSB-/g;
			$string =~ s/\(PUNCT\-CLOSE\+PARENTHETICAL \-RSB\-/\(-RRB- -RSB-/g;
			$string =~ s/\(PUNCT\-OPEN\+PARENTHETICAL \,/\(-LRB- -LRB-/g;
			$string =~ s/\(PUNCT\-CLOSE\+PARENTHETICAL \,/\(-RRB- -RRB-/g;
			$string =~ s/\(PUNCT\-OPEN\+PARENTHETICAL \-/\(-LRB- -LRB-/g;
			$string =~ s/\(PUNCT\-CLOSE\+PARENTHETICAL \-/\(-RRB- -RRB-/g;
			}	
return $string;
}

return 1;
END{}
